using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

using CommunityToolkit.WinUI;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ׸ ÷ - ItemCollection

    /// <summary>
    /// ׸ ÷
    /// </summary>
    public ObservableCollection<string> ItemCollection { get; set; } = [];

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ItemCollection = GetItemCollection(200);

        Loaded += Page_Loaded;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region  ε óϱ - Page_Loaded(sender, e)

    /// <summary>
    ///  ε óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void Page_Loaded(object sender, RoutedEventArgs e)
    {
        StackPanel stackPanel = this.FindDescendant<StackPanel>();

        ListView listView = stackPanel.FindDescendant("listView") as ListView;

        IEnumerable<ListViewItem> listViewItemEnumerable = listView.FindDescendants().OfType<ListViewItem>();

        this.textBlock.Text = listViewItemEnumerable.Count().ToString();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region ׸ ÷ ϱ - GetItemCollection(itemCount)

    /// <summary>
    /// ׸ ÷ ϱ
    /// </summary>
    /// <param name="itemCount">׸ </param>
    /// <returns>׸ ÷</returns>
    private ObservableCollection<string> GetItemCollection(int itemCount)
    {
        ObservableCollection<string> collection = [];

        for(int i = 0; i < itemCount; i++)
        {
            string item = (i % 2) == 0 ? $"{i} - Even" : $"{i} - Odd";

            collection.Add(item);
        }

        return collection;
    }

    #endregion
}